﻿<%@ Page Language="C#" AutoEventWireup="true" Inherits="Sitecore.KomfoConnector.Maintenance.Client.Admin.KomfoConnectorCryptoTool" %>
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
  <title>Komfo Connector Crypto Tool</title>
  <link href="/sitecore/shell/themes/standard/default/WebFramework.css" rel="Stylesheet" />
  <style>
    #progressContainer {
      margin-top: 20px;
    }

    .wf-content {
      height: 100px;
    }

    #progress {
      height: 20px;
      width: 100%;
    }
  </style>

  <script type="text/javascript" src="/sitecore/shell/Controls/lib/jQuery/jquery.js"></script>
  <script type="text/javascript" src="/sitecore/shell/controls/webframework/webframework.js"></script>
</head>
<body>
  <form id="cryptoToolForm" runat="server" class="wf-container">
    <div class="wf-content">
      <h1>Welcome to the Komfo Connector Crypto tool!</h1>
      <p class="wf-subtitle">
        You can use this tool to re-encrypt data with new cryptographic keys. After re-encrypting, you can delete the expired cryptographic keys. 
      </p>
      <p class="wf-subtitle">This process performs two tasks:</p>
      <ol>
          <li>Re-encrypts credentials in all Komfo Clients.</li>
          <li>Cleans the Komfo Connector database to enable the custom audiences synchronization to start from scratch.</li>
      </ol>
      <div class="wf-statebox wf-statebox-warning" style="margin: 2em 0">
        <p>Please remember to:</p>
        <ul>
          <li>Disable Komfo Connector scheduling agents.</li>
          <li>Setup the &quot;<asp:Literal runat="server" ID="CryptoKeysConnectionStringName" Mode="Encode"/>&quot; and &quot;<asp:Literal runat="server" ID="CryptoKeysExpiredConnectionStringName" Mode="Encode"/>&quot; connection strings in the <i>ConnectionStrings.config</i> file.</li>
          <li>Backup the databases.</li>
        </ul>
      </div>
      <div class="wf-progress" id="progressContainer" runat="server">
        <progress id="progress" value="0" max="1" visible="False"></progress>
        <div id="progressText"></div>
        <div id="errorsContainer"></div>
      </div>
      <div class="wf-footer" style="padding-right: 0">
        <asp:Button ID="RunButton" Text="Run" runat="server" OnClick="RunButtonClick" />
      </div>
    </div>
  </form>

  <% if (this.TrackProgress)
     { %>

  <script>
    $(function () {
      getProgress();
      var intervalId = setInterval(getProgress, 2000);
      function getProgress() {
        $.ajax({
          type: "POST",
          url: "KomfoConnectorCryptoTool.aspx/GetProgress",
          data: "{}",
          contentType: "application/json",
          dataType: "json",
          success: function (data) {
            if (data.d) {
              if (data.d.JobFailed) {
                clearInterval(intervalId);
                $('#progressText').html("An error occurred during the update process. Please see the Sitecore logs for details.");
                $('#progress').hide();
                $('#<%=this.RunButton.ClientID%>').removeAttr('disabled');
              } else {
                $('#progress').attr("max", data.d.Total);
                $('#progress').attr("value", data.d.Current);
                $('#progressText').html(data.d.Description + " Processed: " + data.d.Current + " of " + data.d.Total);

                if (data.d.Current === data.d.Total && data.d.Total !== 0) {
                  clearInterval(intervalId);
                  $('#progressText').html("Update is completed. Please see the Sitecore logs for details.");
                  $('#progress').hide();
                  $('#<%=this.RunButton.ClientID%>').hide();
                }
              }
            } else {
              $('#progressText').html("Update has been started...");
            }
          },
          error: function (jqXHR, textStatus, errorThrown) {
            clearInterval(intervalId);
            $('#progressText').html("An error occurred during progress retrieval. Text status: " + textStatus + "; Error thrown: " + errorThrown + ". Please see the Sitecore logs for details.");
            $('#progress').hide();
            $('#<%=this.RunButton.ClientID%>').removeAttr('disabled');
          }
        });
      }
    });
  </script>

  <% } %>
</body>
</html>