﻿define([], function () {
  "use strict";
  return {
    Events: {
      OnConfirmOk: "komfoconnector:confirmation:ok",
      OnConfirmCancel: "komfoconnector:confirmation:cancel"
    },
    
    Types: {
      Information: "InformationDialogTypeImage",
      Error: "ErrorDialogTypeImage",
      Warning: "WarningDialogTypeImage"
    },
    
    Messages: {
      Save: "SaveDialogMessageText",
      Delete: "DeleteDialogMessageText",
      Pause: "PauseDialogMessageText",
      Push: "PushDialogMessageText",
      Resume: "ResumeDialogMessageText",
      Cancel: "CancelDialogMessageText"
    },
    
    Buttons: {
      Ok: "ConfirmationOkButton",
      Cancel: "ConfirmationCancelButton",
      None: "None",
      OkCancel: ""
    },
    
    hideIcons: function () {
      this.app.InformationDialogTypeImage.set("isVisible", false);
      this.app.ErrorDialogTypeImage.set("isVisible", false);
      this.app.WarningDialogTypeImage.set("isVisible", false);
    },
    
    hideButtons: function () {
      this.app.ConfirmationOkButton.set("isVisible", false);
      this.app.ConfirmationCancelButton.set("isVisible", false);
    },
    
    showButtons: function () {
      this.app.ConfirmationOkButton.set("isVisible", true);
      this.app.ConfirmationCancelButton.set("isVisible", true);
    },
    
    unsubscribe: function () {
      this.app.off(this.Events.OnConfirmOk);
      this.app.off(this.Events.OnConfirmCancel);
      this.app.ConfirmationDialogWindow.viewModel.$el.off("hide");
    },
    
    onOk: function () {
      this.beforeCloseDialog();
      if (this.okCb)
        this.okCb.call(this.app);
      this.app.ConfirmationDialogWindow.hide();
    },
    
    onCancel: function () {
      this.beforeCloseDialog();
      if (this.cancelCb)
        this.cancelCb.call(this.app);
      this.app.ConfirmationDialogWindow.hide();
    },
    
    onHide: function () {
      this.beforeCloseDialog();
      if (this.cancelCb)
        this.cancelCb.call(this.app);
    },
    
    beforeCloseDialog: function () {
      this.unsubscribe();
      this.app[this.messageType].set("isVisible", false);
    },
    
    showConfirmation: function (app, iconType, messageType, buttons, okCb, cancelCb) {
      this.app = app;
      this.okCb = okCb;
      this.cancelCb = cancelCb;
      this.messageType = messageType;
      
      this.hideIcons();
      this.hideButtons();
      
      if (iconType && app[iconType])
        app[iconType].set("isVisible", true);
      
      if (messageType && app[messageType])
        app[messageType].set("isVisible", true);
      
      if (buttons) {
        if (app[buttons])
          app[buttons].set("isVisible", true);
      } else {
        this.showButtons();
      }
      app.once(this.Events.OnConfirmOk, this.onOk, this);
      app.once(this.Events.OnConfirmCancel, this.onCancel, this);
      app.ConfirmationDialogWindow.viewModel.$el.on("hide", $.proxy(this.onHide, this));
      app.ConfirmationDialogWindow.show();
    }
  };
});