define(["sitecore"], function (_sc) {
  "use strict";
  return {
    
    createPostOptions: function (url, data) {
      var ajaxOptions = {
        url: url,
        type: "POST",
        data: data,
        headers: {},
        cache: false
      };

      this.addAntiForgeryToken(ajaxOptions);
      
      return ajaxOptions;
    },
    
    putOptions: function (url) {
      var ajaxOptions = {
        url: url,
        type: "PUT",
        headers: {},
        cache: false
      };

      this.addAntiForgeryToken(ajaxOptions);
      
      return ajaxOptions;
    },
    
    deleteOptions: function (url) {
      var ajaxOptions = {
        url: url,
        type: "DELETE",
        headers: {},
        cache: false
      };

      this.addAntiForgeryToken(ajaxOptions);
      
      return ajaxOptions;
    },

    addAntiForgeryToken: function(ajaxOptions) {
      var antiForgeryToken = _sc.Helpers.antiForgery.getAntiForgeryToken();
      ajaxOptions.headers[antiForgeryToken.headerKey] = antiForgeryToken.value;
    }

  };
});