define([], function () {
  "use strict";
  return {
    translation: {},

    addTranslation: function (items) {
      _.each(items, function(item) {
        this.translation[item.itemId] = item.Text;
      }, this);
      
    },
    
    displayMessages: function (messageBar, messages, stringDictionary, formatTextFunc) {
      var that = this;
      messageBar.removeMessages();

      messages.forEach(function (message) {
        that.addMessage(messageBar, message, stringDictionary, formatTextFunc);
      });

      messageBar.set("isVisible", true);
    },

    addMessage: function (messageBar, message, formatTextFunc) {
      var messageText = message.text;
      if (message.id && this.translation[message.id])
        messageText = this.translation[message.id];

      if (formatTextFunc) {
        messageText = formatTextFunc(messageText);
      }
      else if (message.formatTextFunc) {
        messageText = message.formatTextFunc(messageText);
      }

      messageBar.addMessage(message.type, messageText);
    }
  };
});