define(["jquery"], function ($) {
  "use strict";
  return {
    disableWizardTab: function (tabControl, tabId) {
      var tab = tabControl.viewModel.$el.find("> ul li[data-tab-id='" + tabId + "']");
      if (tab) {
        tab.find("a").removeAttr("href");
        tab.addClass("disabled");
        tab.unbind("click");
      }
    },

    disableInactiveWizardTabs: function(tabControl) {
      var selectedTabId = tabControl.get("selectedTab");
      var that = this;
      tabControl.get("tabs").forEach(function (tabId) {
        if (selectedTabId !== tabId) {
          that.disableWizardTab(tabControl, tabId);
        }
      });
    },

    enableWizardTab: function (tabControl, tabId) {
      var tab = tabControl.viewModel.$el.find("> ul li[data-tab-id='" + tabId + "']");
      if (tab) {
        tab.find("a").attr("href", "#");
        tab.removeClass("disabled");

        tab.click(function (event) {
          tabControl.viewModel.onTabClicked.call(tabControl.viewModel, event);
        });
      }
    },

    switchToWizardTab: function (tabControl, shift) {
      var tabs = tabControl.get("tabs");
      var selectedTabId = tabControl.get("selectedTab");
      this.disableWizardTab(tabControl, selectedTabId);

      var selectedTabIndex = $.inArray(selectedTabId, tabs);
      if (selectedTabIndex === -1) return;

      var nextTabIndex = selectedTabIndex + shift;

      if (nextTabIndex >= 0 && nextTabIndex <= tabs.length - 1) {
        tabControl.set("selectedTab", tabs[nextTabIndex]);
      }
    }
  };
});